package chooser;

import fi.jyu.mit.fxgui.CheckBoxChooser;
import fi.jyu.mit.fxgui.Chooser;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.RadioButtonChooser;
import javafx.application.Application;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

/**
 * Esimerkki Chooser-olioiden käytöstä
 * @author vesal
 * @version 17.2.2019
 */
@SuppressWarnings("unused")
public class Jonot extends Application {
    @Override
    public void start(Stage primaryStage) {
        final BorderPane root = new BorderPane();
        // Chooser<Object> chooser = new ListChooser<>();
        // Chooser<Object> chooser = new ComboBoxChooser<>();
        // Chooser<Object> chooser = new RadioButtonChooser<>();
        Chooser<Object> chooser = new CheckBoxChooser<>();
        root.setCenter((Node)chooser);
        alusta(chooser);
        primaryStage.setScene(new Scene(root));
        primaryStage.setTitle("Esimerkki");
        primaryStage.show();
    }

    
    private void alusta(Chooser<Object> chooser) {
        String[] rivit = {"nimi","hetu","katuosoite"};
        chooser.clear();
        chooser.setRivit(rivit);
        chooser.addExample("postinumero");
    }


    /**
     * Käynnistetään käyttöliittymä 
     * @param args komentorivin parametrit
     */
    public static void main(String[] args) {
        launch(args);
    }
}