package modalDialog;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.TextField;
import javafx.stage.Modality;
import javafx.stage.Stage;

/**
 * Kystn kerhon nimi ja luodaan tt varten dialogi.
 * 
 * @author vesal
 * @version 2.1.2016
 */
public class KerhonNimiController implements Initializable {
    
    @FXML private TextField textVastaus;
    private String vastaus = null;

    
    private String getResult() {
        return vastaus;
    }


    private void setDefault(String oletus) {
        textVastaus.setText(oletus);
    }

    
    private void close() {
        ((Stage)textVastaus.getScene().getWindow()).close();
    }
    
    
    @FXML private void handleOK() {
        vastaus = textVastaus.getText();
        close();
    }

    
    @FXML private void handleCancel() {
        close();
    }


    /**
     * Mit tehdn kun dialogi on nytetty
     */
    public void handleShown() {
        textVastaus.requestFocus();
        
    }
    
    @Override
    public void initialize(URL url, ResourceBundle bundle) {
        //        
    }

    
    /**
     * Luodaan nimenkysymisdialogi ja palautetaan siihen kirjoitettu nimi tai null
     * @param modalityStage mille ollaan modaalisia, null = sovellukselle
     * @param oletus mit nime nytetn oletuksena
     * @return null jos painetaan Cancel, muuten kirjoitettu nimi
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        try {
            // Selvitetn tiedoston osoite
            URL url = KerhonNimiController.class.getResource("KerhonNimiView.fxml");
            // Luodaan olio joka lataa tiedoston
            FXMLLoader ldr = new FXMLLoader(url);
            // Ja ladataan tiedoston kuvaama ulkoasu
            Parent root =  ldr.load();
            // selvitetn luotu kontrolleriolio
            final KerhonNimiController dialogCtrl = (KerhonNimiController)ldr.getController();
            // luodaan uusi ikkuna 
            Stage stage = new Stage();
            // ja sen sisll nkym, joka nytt suunnitellun ulkoasun
            stage.setScene(new Scene(root));
            // Vaihdetaan ikkunan otsikkkoa
            stage.setTitle("Kerho");
            // Jos on annettu ikkuna jolle ollaa modaaleja, asetetaan modaalisuus suhteessa
            if ( modalityStage != null ) {
                stage.initModality(Modality.WINDOW_MODAL);
                stage.initOwner(modalityStage);
            } else  // Muutan ollaan modaalisia sovelluksee  
                stage.initModality(Modality.APPLICATION_MODAL);
            // Pyydetn dialogia laittamaan oletustiedot nkyville
            dialogCtrl.setDefault(oletus);
            // laitetaan ikkunalle ksittelij siit kun se nytetn
            stage.setOnShown((e)-> {
                // ja annetaan kytt liittymn ptt mik komponentti oletukseksi
                dialogCtrl.handleShown();
            });
            // Pistetn dialogi nkyville ja odotetaan kunnes se suljetaan
            stage.showAndWait();
            // Kysytn kyttliittymlt tulos ja palautetaan se
            return dialogCtrl.getResult();
        } catch (IOException e) {
            System.err.println(e.toString());
            return null;
        }
    }
}
