package stringgrid;

import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.StringGrid;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TableView;
import javafx.scene.control.TextArea;

/**
 * Esimerkki uudemman StringGridin käytöstä.
 * Tässä on vain tarkoitus esitellä eri ominaisuuksia.
 * Ominaisuuksia pitää katsoa yksittäisinä eikä niitä ole kaikkia
 * pakko käyttää. 
 * 
 * @author vesal
 * @version 24.3.2016
 *
 */
public class NimiJaVuosiController implements Initializable {
    @FXML private StringGrid<?> grid;
    @FXML private TextArea area;
    private int vuosi = 1935;

    
    @FXML void handleNayta() {
         String s = grid.getRivit();
         area.setText(s);
         grid.set("kissa", 1, 1);
    }

    
    @FXML void handleUusi() {
        grid.add("Matti", ""+vuosi);
        vuosi+=10;
    }

    
    @Override
    public void initialize(URL location, ResourceBundle resources) {
        grid.setColumnResizePolicy(TableView.CONSTRAINED_RESIZE_POLICY); // ylim. sarake piiloon
        
        // Mitä tehdään kun editointi lopetetaan painamalla Enter
        grid.setOnGridEdit( (t,obj,s,r,c) -> {
            // area.setText(s + " " + r + " " + c); // pitäisi olla sama kuin:
            area.setText("'" + s + "' " + t.getRowNr() + " " + t.getColumnNr());
            return s .trim();
        });
        

        // Mitä tehdään kun solua muokataan
        // Tässä esimerkissä katsotaan että sarakkeessa 1 on kokonaisluku,
        // muuten muokkaussolu laitetaan punaiseksi 
        grid.setOnGridLiveEdit( (t,obj,s,r,c,tf) -> {
            area.setText("'" + s + "' " + r + " " + c);
            if ( c == 1 ) {
                try {
                    if ( s.length() > 0 ) Integer.parseInt(s);
                } catch (Exception e1) {
                    tf.setStyle("-fx-background-color: red");
                    return null;
                }
                tf.setStyle("");
            }
            return s;
        });
        

        // Asetetaan malliksi tyylejä soluille 
        grid.setStyleClass("virhe,sininen", 1, 1);
        grid.setStyleClass("s1", 0, 0);
        grid.setStyleClass("s2", 1, 0);
        grid.setStyleClass("s3", 2, 0);
        // grid.setEmptyStyleClass("normaali"); // hoituu myös css:llä
        
        // Mitä tehdään kun hiirellä klikataan
        grid.setOnMouseClicked( e -> {
            int r = grid.getRowNr();
            int c = grid.getColumnNr();
            if ( r < 0 || c < 0 ) { grid.refresh(); return; } // ilman tätä css:ät sekaisin jos lajiteltu
            if (  e.getClickCount() == 2) 
               ; //grid.setStyleClass("virhe", r, c); // tämä poistaa valitettavasti editin
            else
                grid.setStyleClass(null, r, c);
                area.setText(grid.get(r, c));
          });
        
        grid.setColumnSortOrderNumber(1);
        grid.setColumnWidth(1, 50);
        
        // grid.setSortable(-1, false); // kielletään lajittelu
    }

    
}